/*
   This file is part of `The Undelete System'
   Copyright (C) 1995 Peter Vanderborght

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   */

#include "globhand.h"

extern void WriteDB();

/*
   This function is called if the time period DELD_TIMER expires.
   It will remove existing message queues and write the database if 
   necessary
   */
void TimedOut(int sig)
{
  struct msqid_ds buf;

  if (inQ >= 0) msgctl(inQ,  IPC_RMID, &buf);
  if (outQ>= 0) msgctl(outQ, IPC_RMID, &buf);

  if (DMAX > 0) WriteDB();

  _exit(0);
}
